/*********************************************************************
 * $Id: temperature.C,v 1.14 1998/08/04 15:35:06 tjko Exp $
 *
 * Copyright (c) 1998  Timo Kokkonen <tjko@iki.fi>
 *
 *
 * This file may be copied under the terms and conditions 
 * of the GNU General Public License, as published by the Free
 * Software Foundation (Cambridge, Massachusetts).
 */

#include <stdio.h>
#include <string.h>

#include "main.H"

static char *rcsid = "$Id: temperature.C,v 1.14 1998/08/04 15:35:06 tjko Exp $";

static S_Socket t_socket, *t_sock = &t_socket;

char *t_addr = NULL;
char *t_port = NULL;
char *t_url = NULL;
char *t_search1 = NULL;
char *t_search2 = NULL;
char *t_search3 = NULL;
char *t_label2 = NULL;
char *t_label3 = NULL;
int  t_timeout;

#define HOT_COLOR 1
#define COLD_COLOR 4

//---------------------------------------------------------------------



void temperature_update(void *v);


void temperature_update1(int, void *v)
{
  if (rcsid);
  temperature_update(v);
}

#define BUF_SIZE 2000

void temperature_update(void *v)
{
  static char tmp1[255],tmp2[255],tmp3[255],buf[1024];
  static char *data=NULL;
  static int data_size,data_res;
  static char *old_ip=NULL, *old_port=NULL;
  int mode=(int)v;

  strcpy(tmp1,"N/A");
  strcpy(tmp2,tmp1);
  strcpy(tmp3,tmp1);


  if (mode==0) { // open connection and add fd to poll list
    if (!old_ip || strcmp(old_ip,t_addr)) {
      show_info("Hostname lookup...(%s)",t_addr);
      Fl::wait();
      if (t_sock->setaddress(t_addr)<0) {
	fprintf(stderr,"jyudesk: Invalid address: %s\n",t_addr);
	show_info("");
	goto pois;
      }
      show_info("");
      if (old_ip) free(old_ip);
      old_ip=strdup(t_addr);
    }
    if (!old_port || strcmp(old_port,t_port)) {
      if (t_sock->setport(t_port)<0) {
	fprintf(stderr,"jyudesk: Invalid port: %s\n",t_port);
	goto pois;
      }
      if (old_port) free(old_port);
      old_port=strdup(t_port);
    }
    if (t_sock->open(1)<=0) {
      fprintf(stderr,"jyudesk: Cannot open socket!\n");
      goto pois;
    }
    data_size=data_res=0;
    Fl::add_fd(t_sock->fd(),FL_WRITE,temperature_update1,(void*)2);
    // fprintf(stderr,"t_sock->open() at %d\n",(int)time(NULL));
    show_info("Updating temperature...");
    return;
  }
  else if (mode==1) { // data received so read it....
    Fl::remove_fd(t_sock->fd());

    if (!data) {
      data=(char*)malloc(BUF_SIZE+1);
      if (!data) exit(-2);
      data_size=BUF_SIZE; data_res=0;
    }

    int wasread;

    do {
      if (data_res>=data_size) {
	data=(char*)realloc(data,data_size+BUF_SIZE);
	data_size+=BUF_SIZE;
      }
    
      wasread=t_sock->read(data+data_res,data_size-data_res);
      if (wasread >=0) {
	data_res+=wasread;
	if (t_sock->error()==EAGAIN) {
	  // fprintf(stderr,"foo %d\n",data_res);
	  Fl::add_fd(t_sock->fd(),FL_READ,temperature_update1,(void*)1);
	  return; // have to wait for more data so we don't want to block...
	}
      } else {
	fprintf(stderr,"jyudesk: read() from socket failed.\n");
      }
    } while (wasread > 0);
    
    data[data_res]=0;
    char *s,*e,t=0;
    if ( (s=strstr(data,t_search1)) != NULL ) {
      s+=strlen(t_search1)+1;
      while (*s==' ') *s++;
      e=strstr(s,"C");
      if (e) { t=*(e+2); *(e+2)=0; }
      strncpy(tmp1,s,sizeof(tmp1));
      if (e) *(e+2)=t;
    }
    if ( (s=strstr(data,t_search2)) != NULL ) {
      s+=strlen(t_search2)+1;
      while (*s==' ') *s++;
      e=strstr(s,"C");
      if (e) { t=*(e+2); *(e+2)=0; }
      strncpy(tmp2,s,sizeof(tmp2));
      if (e) *(e+2)=t;
    }
    if ( (s=strstr(data,t_search3)) != NULL ) {
      s+=strlen(t_search3)+1;
      while (*s==' ') *s++;
      e=strstr(s," ");
      if (e) { t=*(e+0); *(e+0)=0; }
      strncpy(tmp3,s,sizeof(tmp3));
      if (e) *(e+0)=t;
    }
    
    free(data); data=0;
    t_sock->close();
  } 
  else if (mode==2) { // send request....
    Fl::remove_fd(t_sock->fd());
    // fprintf(stderr,"t_sock->write() at %d\n",(int)time(NULL));
    sprintf(buf,"GET %s\r\n",t_url);
    int written = t_sock->write(buf,strlen(buf));
    if (written < (int)strlen(buf)) {
      fprintf(stderr,"jyudesk: Cannot write() to socket! %s\n",
	      t_sock->errstr());
      t_sock->close();
      goto pois;
    }
    Fl::add_fd(t_sock->fd(),FL_READ,temperature_update1,(void*)1);
    return;
  }


  
  main_temp1->value(tmp1);
  if (tmp1[0]=='-') main_temp1->textcolor(COLD_COLOR);
  else main_temp1->textcolor(HOT_COLOR);

  main_temp2->value(tmp2);
  if (tmp2[0]=='-') main_temp2->textcolor(COLD_COLOR);
  else main_temp2->textcolor(HOT_COLOR);
  
  main_temp3->value(tmp3);

 pois:
  Fl::add_timeout(t_timeout*60,temperature_update,0);

  show_info("");
}
